----------------------------------------------------------------------------------
-- Company: 		comp. engr. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    15:50:12 09/01/2011 
-- Design Name: 
-- Module Name:    mux - Behavioral 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity mux is
generic(n: integer := 2); -- n is the number of selection bits.
port(
	sel: 		in std_logic_vector (n - 1 downto 0);
	ch:		in array(0 to 2 ** n - 1) of std_logic_vector(31 downto 0);
	muxout:	out std_logic_vector (31 downto 0);
);
end mux;

architecture Behavioral of mux is

begin
	muxout <= ch(to_integer(unsigned(sel)));
	
end Behavioral;

