----------------------------------------------------------------------------------
-- Company: 		comp. engr. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    15:50:12 09/01/2011 
-- Design Name: 
-- Module Name:    mux - Behavioral 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--use IEEE.NUMERIC_STD.ALL;

entity mux2 is
port(
	sel: 		in std_logic;
	ch1:		in std_logic_vector(31 downto 0);
	ch2:		in std_logic_vector(31 downto 0);
	muxout:	out std_logic_vector (31 downto 0)
);
end mux2;

architecture Behavioral of mux2 is

begin
    SEL_PROCESS: process (sel,ch1,ch2) 
    begin 
      case sel is  
        when '0'  => muxout <= ch1;  
        when '1'  => muxout <= ch2;  
        when others => muxout <= (muxout'range => 'Z');  
      end case;  
    end process SEL_PROCESS; 
end Behavioral;

