----------------------------------------------------------------------------------
-- Company: 		comp. engr. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    11:58:12 09/02/2011 
-- Design Name: 
-- Module Name:    mux - Behavioral 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
-- "The idea of wilderness needs no defense. It only needs more defenders."
-- - Edward Abbey
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--use IEEE.NUMERIC_STD.ALL;

entity mux4 is
port(
	sel: 		in std_logic_vector(1 downto 0);
	ch1:		in std_logic_vector(31 downto 0);
	ch2:		in std_logic_vector(31 downto 0);
	ch3:		in std_logic_vector(31 downto 0);
	ch4:		in std_logic_vector(31 downto 0);
	muxout:	out std_logic_vector (31 downto 0)
);
end mux4;

architecture Behavioral of mux4 is

begin
    SEL_PROCESS: process (sel,ch1,ch2,ch3,ch4) 
    begin 
      case sel is  
        when "00"  => muxout <= ch1;  
        when "01"  => muxout <= ch2;  
		  when "10"  => muxout <= ch3;  
		  when "11"  => muxout <= ch4;  
        when others => muxout <= (muxout'range => 'Z');  
      end case;  
    end process SEL_PROCESS; 
end Behavioral;
